/*
@Title BLE keyboard
@Author Geert Roumen -edited for BLE-pedal by Marcel van Dijk
@Institute Umeå Institute of Design
@Date 21-04-2020
 
@Hardware
 
Any ESP32 dev board would do

D12-D13   Button pins  
GND       Connected to the other leg of the button
*/

#include <BleKeyboard.h>
//Set the name of the bluetooth keyboard (that shows up in the bluetooth menu of your device)
BleKeyboard bleKeyboard("protoPedal");
int ledPin = 14;
byte buttonPins[] =    {13,  12};
int buttonChars[] =  {218, 217}; //218 for up arrow, 217 for down arrow: https://www.arduino.cc/en/Reference/KeyboardModifiers
//initialze the perceived state of the buttons as not-pressed:
boolean buttonStates[] = {HIGH, HIGH};


void setup() { 
  //Start the Serial communication (with the computer at 115200 bits per second)
  Serial.begin(115200);
  //Send this message to the computer
  Serial.println("Starting BLE work!");
  //Begin the BLE keyboard/start advertising the keyboard (so phones can find it)
  bleKeyboard.begin();
  //Make the button pin an INPUT_PULLUP pin, which means that it is normally HIGH, untill it is pressed/ connected to the GND/0V
  for(int i=0;i<sizeof(buttonPins);i++){
    pinMode(buttonPins[i], INPUT_PULLUP);  
    }
  //set the pinmode for the LED
  pinMode(ledPin, OUTPUT);  
}

void loop() {
  if (bleKeyboard.isConnected()) {
    digitalWrite(ledPin, HIGH);
    for(int i=0;i<sizeof(buttonPins);i++){
      boolean state = digitalRead(buttonPins[i]);
      if (state != buttonStates[i]){
        if (state == LOW){
          bleKeyboard.write(buttonChars[i]);
          //Serial.println("pressed");
          }else{
            //Serial.println("released");
            }
            buttonStates[i] = state;
        }
      }
    } else {
    //if the ESP32 is not connected (yet) turn off the LED
    digitalWrite(ledPin, LOW);
    }    
  delay(10);
}
